* PACKAGE LEIGEN  !" ͭͲ
*
*"  [HIS] 92/12/14(takepiro) ֹ׻եȥ׻
*"        92/12/18(takepiro)  Numerical Recipies 
*"        93/01/13(takepiro)  4 ٷ׻
*"        93/05/10(takepiro)  顼ѹ
*"        93/06/11(takepiro)  ͭؿ׻åƳ
*
**********************************************************************
      SUBROUTINE LEIGEN
     M            ( AMAT   , 
     O              EIGVLR , EIGVLI  ,
     O              EIGVCR , EIGVCI  ,
     O              IERR   , 
     I              MATDIM , OEIVEC    )
*
      IMPLICIT NONE
*
#include        "zcdim.F"                    !" 
#include        "zldim.F"                    !" 礭
*
*   [MODIFY] 
      REAL      AMAT  ( MATDMX, MATDMX )     !" 
*
*   [OUTPUT] 
      REAL      EIGVLR( MATDMX )             !" ͭͼ¿
      REAL      EIGVLI( MATDMX )             !" ͭ͵
      REAL      EIGVCR( MATDMX, MATDMX )     !" ͭ٥ȥ¿
      REAL      EIGVCI( MATDMX, MATDMX )     !" ͭ٥ȥ
      INTEGER   IERR                         !" ֥롼󥨥顼
*
*   [INPUT] 
      INTEGER   MATDIM                       !" ׻뼡
      LOGICAL   OEIVEC                       !" ͭؿ׻å
*
*   [INTERNAL WORK] 
c$$$      COMMON    /COMWRK/ 
*
      DOUBLE PRECISION   WR( MATDMX )             !" ͭͼ¿
      DOUBLE PRECISION   WI( MATDMX )             !" ͭ͵
      DOUBLE PRECISION   SCALE ( MATDMX )         !" 󥰾
      INTEGER            LOW, IGH                 !" 
      DOUBLE PRECISION   INT   ( MATDMX )         !" إå٥륰Ѵ
      DOUBLE PRECISION   A     ( MATDMX, MATDMX ) !" ͭ٥ȥ
      DOUBLE PRECISION   Z     ( MATDMX, MATDMX ) !" ͭ٥ȥ
*
      CHARACTER HERR*8                       !" 顼ֹʸѿ
      INTEGER   NERR                         !" ʸĹ
      INTEGER   LENC                         !" ʸĹ֤ؿ
      INTEGER            I, J 
*
*"  < 0. 򥳥ԡ >
*
      DO 100 J = 1, MATDIM
         DO 100 I = 1, MATDIM
            A( I ,J ) = AMAT( I, J )
 100  CONTINUE 
*
*"  < 1. Х󥷥 >
*
      CALL BALANC
     I      (  MATDMX , MATDIM , 
     M         A      ,
     O         LOW    , IGH    ,SCALE  )
*
*"  < 2. إå٥륰Ѵ >
*
      CALL ELMHES
     I      (  MATDMX , MATDIM , 
     I         LOW    , IGH    , 
     M         A      , INT      )
*
      CALL ELTRAN
     I      (  MATDMX , MATDIM , 
     I         LOW    , IGH    , 
     I         A      , INT    , 
     O         Z                 )
*
*"  < 3. ͭ, ͭ٥ȥη׻ >
*
      CALL HQR2
     I      (  MATDMX , MATDIM , 
     I         LOW    , IGH    , 
     I         A      , 
     O         WR     , WI     , 
     M         Z      , 
     O         IERR              )
*
      IF ( IERR .NE. 0 ) THEN
         WRITE( HERR , '(I5)' ) IERR
         CALL CLADJ( HERR )
         NERR = LENC( HERR )
         CALL MSGDMP( 'W', 'LEIGEN', 
     &         'IERR = '//HERR(1:NERR)//' : EIGENVALUES NOT CORRECT ' )
      ENDIF
*
*
*"  < 4. ͭ٥ȥη׻ >
*
      IF ( OEIVEC ) THEN
         CALL BALBAK
     I      (  MATDMX , MATDIM , 
     I         LOW    , IGH    , 
     I         SCALE  , MATDIM , 
     M         Z                  )
      ENDIF
*
*"  < 5. ͭ٥ȥ¤ؤ > 
*
      CALL EIGSRT
     O      (  EIGVLR , EIGVLI , 
     O         EIGVCR , EIGVCI ,
     I         WR     , WI     ,
     I         Z      , 
     I         MATDIM , OEIVEC   )
*
*"  < 5. λ > 
*
      RETURN
      END
************************************************************************
      SUBROUTINE EIGSRT      !" ͭ͸ͭ٥ȥ¤Ѥ
     O      (  EIGVLR , EIGVLI , 
     O         EIGVCR , EIGVCI , 
     I         WR     , WI     ,
     I         Z      , 
     I         MATDIM , OEIVEC   )
*
      IMPLICIT NONE
*
#include        "zcdim.F"                    !" 
#include        "zldim.F"                    !" 礭
*
*   [OUTPUT] 
      REAL      EIGVLR( MATDMX )             !" ͭͼ¿
      REAL      EIGVLI( MATDMX )             !" ͭ͵
      REAL      EIGVCR( MATDMX, MATDMX )     !" ͭ٥ȥ¿
      REAL      EIGVCI( MATDMX, MATDMX )     !" ͭ٥ȥ
*
*   [INPUT]
      DOUBLE PRECISION   WR( MATDMX )             !" ͭͼ¿
      DOUBLE PRECISION   WI( MATDMX )             !" ͭ͵
      DOUBLE PRECISION   Z ( MATDMX, MATDMX )     !" ͭ٥ȥ
*
      INTEGER   MATDIM                       !" ׻뼡
      LOGICAL   OEIVEC                       !" ͭؿ׻å
*
*   [INTERNAL WORK]
      INTEGER   J, K
      INTEGER   INDX  ( MATDMX )             !" ֳǼ
      REAL      WORK  ( MATDMX,MATDMX )      !" ΰ
*
*" < 0. ͭͤ촹 >
*
      DO 100 K = 1, MATDIM
         EIGVLR( K ) = WR( K )
         EIGVLI( K ) = WI( K )
 100  CONTINUE 
*
*" < 1. ͭ٥ȥ촹 >
*
      IF ( OEIVEC )THEN
         DO 1000 K = 1, MATDIM
            IF ( EIGVLI(K) .EQ. 0.0 ) THEN
               DO 1100 J = 1, MATDIM
                  EIGVCR( J,K ) = Z( J,K )
                  EIGVCI( J,K ) = 0.
 1100          CONTINUE
*
            ELSE IF ( EIGVLI(K) .GE. 0.0 ) THEN
               DO 1200 J = 1, MATDIM
                  EIGVCR( J,K ) =  Z( J,K ) 
                  EIGVCI( J,K ) =  Z( J,K+1 )
 1200          CONTINUE
*
            ELSE
               DO 1300 J = 1, MATDIM
                  EIGVCR(J,K) =    EIGVCR( J,K-1 )
                  EIGVCI(J,K) =  - EIGVCI( J,K-1 )
 1300          CONTINUE
            ENDIF
 1000    CONTINUE
      ENDIF
*
*"  < 2. ͭͤΥ >
*
      CALL INDEXX                                   !" ͭͼ¿ξ
     I       ( MATDIM , EIGVLR ,
     O         INDX              )
*
      CALL COPY( WORK, EIGVLR, MATDIM )             !" ͭͼ¿
      DO 2100 J = 1, MATDIM                         !" ͭͼ¿礭
         EIGVLR( J ) = WORK( INDX( MATDIM-J+1 ),1  )
 2100 CONTINUE
*
      CALL COPY( WORK, EIGVLI, MATDIM )             !" ͭ͵
      DO 2200 J = 1, MATDIM                         !" ͭͼ¿礭
         EIGVLI( J ) = WORK( INDX( MATDIM-J+1 ),1 )
 2200 CONTINUE
*
*
*"  < 3. ͭ٥ȥΥ >
*
      IF ( OEIVEC )THEN                 
         CALL COPY( WORK, EIGVCR, MATDMX*MATDIM )   !" ͭ٥ȥ¿
         DO 2300 K = 1, MATDIM                      !" ͭͼ¿礭
            DO 2300 J = 1, MATDIM
               EIGVCR( J,K ) = WORK( J,INDX( MATDIM-K+1 ) )
 2300    CONTINUE
*
         CALL COPY( WORK, EIGVCI, MATDMX*MATDIM )   !" ͭ٥ȥ
         DO 2400 K = 1, MATDIM                      !" ͭͼ¿礭
            DO 2400 J = 1, MATDIM
               EIGVCI( J,K ) = WORK( J,INDX( MATDIM-K+1 ) )
 2400    CONTINUE
      ENDIF
*
      RETURN
      END
