*" PACKAGE DVOPTT !" ƥȥ롼
***********************************************************************
      PROGRAM DVOPTT                        !" ᥤ롼
*
*"    Boussinesq ǥ
*"      one-level time integration
*
      IMPLICIT NONE
*
*   [PARAM]
#include        "zcdim.F"                    !" ʻ, ȿ
#include        "zhdim.F"                    !" ʸʸ
#include        "zccom.F"                    !" ɸʪ
*
*   [VAR]
      REAL       GDU   ( IDIM, JDIM, 0:KMAX )  !"    
      REAL       GDV   ( IDIM, JDIM, 0:KMAX )  !"    
      REAL       GDW   ( IDIM, JDIM, 0:KMAX )  !" ľ 
      REAL       GDT   ( IDIM, JDIM, 0:KMAX )  !"    
      REAL       GDTOR ( IDIM, JDIM, 0:KMAX )  !" ȥ 
      REAL       GDPOR ( IDIM, JDIM, 0:KMAX )  !" ݥ 
*
*"    COMMON /COMCON/ ( include ZCCOM )
*     REAL       ERI                          !" 
*     REAL       ERO                          !" 
*     REAL       ETA                          !" /
*"    COMMON /COMCON/ end
*"       : ʪѥ᡼
*
*"       : ɸ
      REAL       ALAT  ( JDIM )        !" 
      REAL       DLAT  ( JDIM )        !" ٲٽ
      REAL       ALON  ( IDIM )        !" 
      REAL       DLON  ( IDIM )        !" ٲٽ
      REAL       ARAD  ( 0:KMAX )      !" ٥()
      REAL       DRAD  ( 0:KMAX )      !" ()
*
      INTEGER    NMO   ( 2, 0:MMAX, 0:LMAX ) !" ڥȥź
      REAL       FLAPLA( NMDIM  )            !" ץ饷η
      REAL       EDEL  ( NMDIM  )            !" ơĢա
*
      REAL       UVFACT ( IDIM, JDIM )       !" uU Υե
*
      REAL       WDTOR ( NMDIM , 0:KMAX     )  !" ȥ 
      REAL       WDPOR ( NMDIM , 0:KMAX     )  !" ݥ 
*
*"       : ֥ƥåץѥ᡼
      INTEGER    IT             !" 롼ץ
*
*   [WORK]
      COMMON    /COMWRK/ WORK
      REAL       WORK  ( NWORK )       !" ΰ
      INTEGER    I, J, K
      REAL       PI, XSI
*
*" << SETPUP :  >>
*
      PI = 4.0*ATAN(1.0D0)
*
      CALL ATPSET               !" 
     I      ( 1.0 , 0 , 1.0 )
*
      CALL ACRGET                      !" ɸ
     O         ( ALON  , DLON  ,
     O           ALAT  , DLAT  ,
     O           ARAD  , DRAD   )
*
      CALL IHSTRT                      !" Ϥ
*
      CALL DSETC                       !" ڥȥ
     O      ( NMO   , FLAPLA, EDEL  , UVFACT, 
     C        ALAT  , DLAT                      )
*
*======================================================================
*
*" << ƥȷ׻ >>
*
*"    < 0. ®پ >>
*
      CALL RESET( WDTOR, NMDIM*KDIM )
      CALL RESET( WDPOR, NMDIM*KDIM )
*
*             P^1_1 = \cos\varphi = \sqrt{1-\mu^2}
*
      DO K=0,KMAX
         XSI=( ARAD(K)-ERI )/ (ERO-ERI)
c$$$         WDPOR( NMO(1,1,0), K ) = SIN( PI*XSI )
         WDPOR( NMO(1,0,1), K ) = SIN ( PI*XSI )
      ENDDO
*
*"    < 1. ݥƥ󥷥 -> ٥ȥʻ >>
*
      IT = 1
*
      CALL POTVEL     !" ʦ,˥ڥȥ   ʣ,,ס˳ʻ
     O      ( GDU   , GDV   , GDW   , 
     I        WDTOR , WDPOR , 
     C        FLAPLA, UVFACT        ,
     C        ARAD  , DRAD            )
*
      CALL W2G
     O         ( GDTOR ,
     I           WDTOR ,
     I           ' ', 'POS ', KDIM )
      CALL W2G
     O         ( GDPOR ,
     I           WDPOR ,
     I           ' ', 'POS ', KDIM )
*
      CALL WRRSTR               !" ꥹȥե񤭹
     I      ( GDU   , GDV   , GDW   , GDT   , 
     I        GDTOR , GDPOR ,
     I        IT                               )
*
*"    < 2. ٥ȥʻ -> ݥƥ󥷥 >>
*
      IT = 2
      CALL G2WPOT    !" ٥ȥ  ȥݥʬ
     O     ( WDTOR , WDPOR ,
     I       GDU   , GDV   , GDW   ,
     C       UVFACT, FLAPLA,
     C       ARAD  , DRAD              )
*
      CALL W2G
     O         ( GDTOR ,
     I           WDTOR ,
     I           ' ', 'POS ', KDIM )
      CALL W2G
     O         ( GDPOR ,
     I           WDPOR ,
     I           ' ', 'POS ', KDIM )
*
      CALL WRRSTR               !" ꥹȥե񤭹
     I      ( GDU   , GDV   , GDW   , GDT   , 
     I        GDTOR , GDPOR ,
     I        IT                               )
*
*======================================================================
*
      CALL IHEND                       !" Ϥκǽ
*
      STOP
      END
