* PACKAGE ALCRT !" ϥᥤ(׳)
*                  ver 1.2              93/09/27 takepiro
*                  ver 1.90             99/11/15 takepiro æ GTOOL 
*                                       99/11/21 
***********************************************************************
      PROGRAM GLCRT                          !" ᥤ롼
*
*"    Boussinesq ǥ
*"      (׳)  : Bracket method ( Ϥߤˡ? )
*
      IMPLICIT NONE
*
*"   [PARAM]
#include        "zcdim.F"                    !" ʻ, ȿ
#include        "zldim.F"                    !" ѥ᥿, 
#include        "zccom-dbl.F"                !" ɸʪ
*
*   [VAR]
      DOUBLE PRECISION  GAU   ( IDIM, JDIM, 0:KMAX )  !"    
      DOUBLE PRECISION  GAV   ( IDIM, JDIM, 0:KMAX )  !"    
      DOUBLE PRECISION  GAW   ( IDIM, JDIM, 0:KMAX )  !" ľ 
      DOUBLE PRECISION  GAT   ( IDIM, JDIM, 0:KMAX )  !"    
      DOUBLE PRECISION  GATOR ( IDIM, JDIM, 0:KMAX )  !" ȥ 
      DOUBLE PRECISION  GAPOR ( IDIM, JDIM, 0:KMAX )  !" ݥ 
*"       : ʻǡ(t) <DYNMCS>  ʻǡ(t+t)
*
      DOUBLE PRECISION  FREQ                  !" ư
*
      LOGICAL           ORSTR                 !" ͭؿϤ뤫ݤ
*"       : 
*
*   [ONCE]
*"       : ¸ѥ᡼
*
*"       : ֥ƥåץѥ᡼
*
*"    COMMON /COMCON/ ( include ZCCOM )
*     REAL       ERI                          !" 
*     REAL       ERO                          !" 
*     REAL       ETA                          !" /
*"    COMMON /COMCON/ end
*"       : ʪѥ᡼
*
      DOUBLE PRECISION  ALAT  ( JDIM )        !" 
      DOUBLE PRECISION  DLAT  ( JDIM )        !" ٲٽ
      DOUBLE PRECISION  ALON  ( IDIM )        !" 
      DOUBLE PRECISION  DLON  ( IDIM )        !" ٲٽ
      DOUBLE PRECISION  ARAD  ( 0:KMAX )      !" ٥()
      DOUBLE PRECISION  DRAD  ( 0:KMAX )      !" ()
*"       : ɸ
*
*   [WORK]
      COMMON    /COMWRK/ WORK
      DOUBLE PRECISION   WORK  ( MATDMX*MATDMX )  !" ΰ
*
      INTEGER          MFIX( MDIM )          !" ȿ
*
      DOUBLE PRECISION RAYL( RDIM )          !" 쥤꡼(ߡ)
      DOUBLE PRECISION TAYL( TDIM )          !" ƥ顼
      DOUBLE PRECISION TAU ( TDIM )          !" ƥ顼
      DOUBLE PRECISION PRND( PDIM )          !" ץɥ
*
      INTEGER          MSTEP , MEND          !" ȿη׻
      INTEGER          RSTEP , REND          !" 쥤꡼η׻(ߡ)
      INTEGER          TSTEP , TEND          !" ƥ顼η׻
      INTEGER          PSTEP , PEND          !" ץɥη׻
*
      DOUBLE PRECISION RAYLM                 !" 쥤꡼
      DOUBLE PRECISION GRMXM                 !" ĹΨ
      INTEGER          IT    , ITMAX         !" ȿ, ȿ
      DOUBLE PRECISION RAYERR                !" 쥤꡼еƸ
      DOUBLE PRECISION RAYLL , RAYLU         !" 쥤꡼, 
      DOUBLE PRECISION GRMXL , GRMXU         !" ĹΨ
*
      LOGICAL    OCONV                 !" «Ƚꥹå
      INTEGER    MODE                  !" ϸͭؿΥ⡼ֹ
*                                      !" ( 1 ǺĹΨ )
      INTEGER    IUNIT                 !" ɸֹ
      INTEGER    IFPAR, JFPAR
*
*" << SETPUP :  >>
*
*XOCL PROCESSOR P(3)
*
      CALL GLIGET( 'MSGUNIT', IUNIT )
      WRITE ( IUNIT, * ) ' LINEAR ANALYSIS GLCRT'
     &                   //NAME
     &                   //' ver.1.9, 99/11/15'
*         
      CALL CLCSTR ( 'SETUP' )
      CALL YPREP                       !" ƥ 
*
      CALL SETLPR                      !" ѥ᥿ϰ
     O       ( MODE   , ORSTR  ,
     O         MFIX   , MEND   ,
     O         RAYL   , TAYL   , TAU    , PRND   ,
     O         REND   , TEND   , PEND              )
*
      CALL ACRGET                      !" ɸ
     O         ( ALON  , DLON  ,
     O           ALAT  , DLAT  ,
     O           ARAD  , DRAD   )
*
      CALL SETCPR               !" ׳ͷ׻ѥѥ᥿
     O         ( ITMAX  , RAYERR , 
     O           RAYLL  , RAYLU    )
*
      CALL IHSTRT                      !" Ϥ
*
      CALL CLCEND ( 'SETUP' )
*
*  << LOOP : <************* ᥤ󡦥롼 >>
*
*XOCL PARALLEL REGION
*XOCL SPREAD DO
*
      DO 9000 MSTEP = 1, MEND
         DO 9000 PSTEP = 1, PEND
            DO 9000 TSTEP = 1, TEND
               CALL CLCSTR( 'MATRIX' )
*
               CALL GLISET( 'MSGUNIT', MSTEP+10 )
               IUNIT = MSTEP + 10
               CALL REWNML ( IFPAR , JFPAR )
               CALL SETNML ( IFPAR , IUNIT )
*
*     << START : ƥåפϤν >>
*
               CALL ATPSET      !" 
     I              ( REAL(MFIX(MSTEP)) , MFIX(MSTEP) , 1.0 )
*
c$$$               CALL SETCPR      !" ׳ͷ׻ѥѥ᥿
c$$$     O              ( ITMAX  , RAYERR , 
c$$$     O                RAYLL  , RAYLU    )
*
               CALL LANAL
     O                ( GAU   , GAV   , GAW   , GAT   ,
     O                  GATOR , GAPOR , 
     O                  GRMXL , FREQ , 
     I                  MFIX(MSTEP), 
     I                  RAYLL , TAU(TSTEP), PRND(PSTEP), 
     I                  ORSTR , MODE ,
     C                  ALON  , DLON  , ALAT  , DLAT  ,
     C                  ARAD  , DRAD                    )
*
               IF ( GRMXL .GT. 0 )THEN
		  WRITE( IUNIT, * ) GRMXL
                  CALL MSGDMP
     &                   ('E','ALCRT',
     &                    'LOWER RAYLEIGH NUMBER SHOULD BE SMALLER')
               ENDIF
*
               CALL LANAL
     O                ( GAU   , GAV   , GAW   , GAT   ,
     O                  GATOR , GAPOR , 
     O                  GRMXU , FREQ  , 
     I                  MFIX(MSTEP), 
     I                  RAYLU , TAU(TSTEP), PRND(PSTEP), 
     I                  ORSTR , MODE  , 
     C                  ALON  , DLON  , ALAT  , DLAT  ,
     C                  ARAD  , DRAD                    )
*
               IF ( GRMXU .LT. 0 )THEN
                  CALL MSGDMP
     &                   ('E','ALCRT',
     &                    'UPPER RAYLEIGH NUMBER SHOULD BE LARGER')
               ENDIF
*
               RAYLM = RAYLU
               GRMXM = GRMXU
*
*"    << ʬˡ loop START ------------------------------>>
* 
               DO 1000 IT = 1, ITMAX
*
c$$$                  CALL UBISEC          !" 2 ʬˡˤο
c$$$                  CALL URFLSP          !" False Point ˡˤο
                  CALL UBRENT          !" Brent ˡˤο
     M                 ( RAYLL , RAYLU  , RAYLM  , 
     M                   GRMXL , GRMXU  , GRMXM  , 
     O                   OCONV  ,
     I                   RAYLM*RAYERR              )
*
                  IF ( OCONV ) GOTO 1100                !" iteration λ
*
                  CALL LANAL
     O                   ( GAU   , GAV   , GAW   , GAT   ,
     O                     GATOR , GAPOR , 
     O                     GRMXM , FREQ  , 
     I                     MFIX(MSTEP), 
     I                     RAYLM , TAU(TSTEP), PRND(PSTEP), 
     I                     ORSTR , MODE  , 
     C                     ALON  , DLON  , ALAT  , DLAT  ,
     C                     ARAD  , DRAD                    )
*
 1000          CONTINUE 
*
               CALL MSGDMP                              !" «
     &                ('W','ALCRT',
     &                 'RAYLEIGH NUMBER NOT CONVERGE' )
*
*"    <<-------------------------------- ʬˡ loop END >>
*
 1100          CONTINUE 
*
      CALL CLCEND( 'MATRIX' )
*
*"    << OUTPUT : ǡ >>
*
               CALL CLCSTR( 'OUTPUT' )
*
               WRITE ( IUNIT, * ) 
               WRITE ( IUNIT, * ) ' m  : ', MFIX(MSTEP) 
               WRITE ( IUNIT, * ) ' Ta : ', TAU(TSTEP)**2
               WRITE ( IUNIT, * ) ' Pr : ', PRND(PSTEP)
*
               WRITE ( IUNIT, * ) ' RAYLEIGH NUMBER : ', RAYLM
               WRITE ( IUNIT, * ) ' FREQENCY        : ', FREQ
               WRITE ( IUNIT, * ) ' ITERATION       : ', IT
               WRITE ( IUNIT, * ) ' GROWTH RATE     : ', GRMXM
               WRITE ( IUNIT, * ) ' R. NUMBER ERROR : ', 
     &             MAX( ABS(RAYLU-RAYLM), ABS(RAYLM-RAYLM) ) / RAYLM
               WRITE ( IUNIT, * ) 
*
               IF ( ORSTR ) THEN  !" ٤κͤǵʲ
                  CALL ANORML
     I                 ( GAU   , GAV   , GAW   , GAT   , 
     I                   GATOR , GAPOR , 
     I                   'GAT'                           )
*
                  CALL WRRSTR   !" ꥹȥե񤭹
     I                 ( GAU   , GAV   , GAW   , GAT   , 
     I                   GATOR , GAPOR , 
     I                   MFIX(MSTEP)                 )
               ENDIF
*
               CALL CLCEND( 'OUTPUT' )
*
*" << LEND : ᥤ󡦥롼׽ *************> >>
*
 9000 CONTINUE 
*
*XOCL END SPREAD DO
*XOCL END PARALLEL REGION
*
      CALL IHEND                       !" Ϥκǽ
*
      CALL CLCOUT                      !" CPUֽ
      CALL YFINE                       !" ƥ
*
      STOP
      END
***********************************************************************
      SUBROUTINE SETCPR                !" ׳ͷ׻ѥѥ᥿
     O             ( IMAX , ERR  , 
     O               RL   , RU       )
*
      IMPLICIT NONE
*
      INTEGER    IMAX                  !" ȿ
      DOUBLE PRECISION       ERR                   !" 쥤꡼еƸ
      DOUBLE PRECISION       RL    , RU            !" 쥤꡼, 
*
      INTEGER    ITMAX                 !" ȿ
      DOUBLE PRECISION       RAYERR                !" 쥤꡼еƸ
      DOUBLE PRECISION       RAYLL , RAYLU         !" 쥤꡼, 
*
      SAVE
*
      DATA       ITMAX         / 20 /
      DATA       RAYERR        / 1e-6 / 
      DATA       RAYLL, RAYLU  / 1e5, 1e6 /
*
      NAMELIST   /NMCRT/  ITMAX , RAYERR , RAYLU, RAYLL
*
      INTEGER    IFPAR, JFPAR
      LOGICAL    OFIRST
      DATA       OFIRST / .TRUE. /
*
      IF ( OFIRST )THEN
         OFIRST = .FALSE.
         CALL   REWNML ( IFPAR , JFPAR )
         READ   ( IFPAR, NMCRT , END=1190 )
 1190    WRITE  ( JFPAR, NMCRT  )
      ENDIF
*
      IMAX = ITMAX
      ERR  = RAYERR
      RL   = RAYLL
      RU   = RAYLU
*
      RETURN
      END
**********************************************************************
* PACKAGE UBISEC  !" ʬˡˤβο
*
*"[HIS]  93/07/03(takepiro) Numerical Recipies Sec.9.3 ܿ(ZBRENT) 
*
*"    3 δؿͤβꤹ. ؿͤ׻ܥ롼
*"    ֤ŬѤ뤳ȤˤͿ줿٤βꤹ. 
*
**********************************************************************
      SUBROUTINE UBRENT              !" Brent ˡˤβο
     M              ( X1   , X2   , X   , 
     M                FX1  , FX2  , FX  , 
     O                OCNV ,
     I                TOL                  )
*
      IMPLICIT NONE
*
*" [MODIFY]
      DOUBLE PRECISION   X1           !" ϰϤ 1
      DOUBLE PRECISION   X2           !" ϰϤ 2
      DOUBLE PRECISION   X            !" 
*
      DOUBLE PRECISION   FX1          !" X1 ˤؿ
      DOUBLE PRECISION   FX2          !" X2 ˤؿ
      DOUBLE PRECISION   FX           !" X  ˤؿ
*
*" [OUTPUT]
      LOGICAL OCNV        !" «ݤ
*
*" [INPUT]
      DOUBLE PRECISION   TOL          !" «Ƚ
*
*" [INTERNAL WORK]
      DOUBLE PRECISION   D, E, P, Q, R, S, XM, TOL1
      DOUBLE PRECISION   EPS                    !" ư
      INTEGER IUNIT                 !" ɸֹ
      LOGICAL OFIRST
      DATA    OFIRST / .TRUE. /
*
      DOUBLE PRECISION    RR , RP
      DOUBLE PRECISION*8  DELTPQ
      DOUBLE PRECISION*8  DELTPD
      DOUBLE PRECISION    DELTPS
      DATA    DELTPQ / 1.0 D-28 /         !' ٤μ«
      DATA    DELTPD / 1.0 D-14 /         !'   ٤μ«
      DATA    DELTPS / 1.0 E-7  /         !'   ñ٤μ«
*
      SAVE
*
*"  < 0. ư٥å >
*
      IF( OFIRST )THEN
         OFIRST = .FALSE.
         CALL GLIGET( 'MSGUNIT', IUNIT )
         WRITE ( IUNIT, * ) ' BRENT METHOD : 93/07/05'
*
         RR  = 1.
         RP = RR + DELTPQ
         IF ( RP .GT. RR ) THEN
            WRITE ( IUNIT, * ) ' precision check .. ', RP
            WRITE ( IUNIT, * ) ' REAL*16 is used in UBRENT'
            EPS = DELTPQ
         ELSE
            RR  = 1.
            RP = RR + DELTPD
            WRITE ( IUNIT, * ) ' precision check .. ', RP
            IF ( RP .GT. RR ) THEN
               WRITE ( IUNIT, * ) ' REAL*8 is used in UBRENT'
               EPS = DELTPD
            ELSE
               WRITE ( IUNIT, * ) ' REAL*4 is used in UBRENT'
               EPS = DELTPS
            ENDIF
         ENDIF
*
      ENDIF
*
*"  < 1. ֤ >
*
      IF ( FX * FX2 .GT. 0. ) THEN
         X2  = X1
         FX2 = FX1
         D   = X - X1
         E   = D
      ENDIF
      IF(ABS(FX2).LT.ABS(FX)) THEN
         X1  = X
         X   = X2
         X2  = X1
         FX1 = FX
         FX  = FX2
         FX2 = FX1
      ENDIF
*
*"  < 2. «Ƚ >
*
      TOL1 = 2.  * EPS * ABS(X) + 0.5*TOL
      XM   = 0.5 * ( X2 - X )
*
      IF(  ABS(XM) .LE. TOL1 .OR. FX. EQ.0. )THEN
         OCNV = .TRUE.
         RETURN
      ENDIF
*
*"  < 3. ο >
*
      IF(  ABS(E).GE.TOL1 .AND. ABS(FX1).GT.ABS(FX)  ) THEN
         S=  FX / FX1
         IF ( X1 .EQ. X2 ) THEN                  !" Ϥߤˡ
            P = 2. * XM * S
            Q = 1.-S
         ELSE                                    !"  2 ؿ
            Q = FX1 / FX2
            R = FX  / FX2
            P = S *( 2.*XM*Q*(Q-R)-(X-X1)*(R-1.) )
            Q = (Q-1.)*(R-1.)*(S-1.)
         ENDIF
         IF(P.GT.0.) Q=-Q
         P=ABS(P)
         IF( 2.*P .LT. MIN(3.*XM*Q-ABS(TOL1*Q),ABS(E*Q)) ) THEN
            E = D                           !" ͤ
            D = P / Q
         ELSE
            D = XM                          !" 2 ʬˡˤ
            E = D
         ENDIF
      ELSE
         D=XM                               !" 2 ʬˡˤ
         E=D
      ENDIF
*
      X1  = X                       !"  ο֤ͤüȤ¸
      FX1 = FX
*
      IF(  ABS(D) .GT. TOL1 ) THEN  !" ͤη׻
         X  = X + D
      ELSE
         X  = X + SIGN(TOL1,XM)
      ENDIF
*
      OCNV = .FALSE.
*
      RETURN
      END
************************************************************************
      SUBROUTINE ANORML
     M            ( GAU   , GAV   , GAW   , GAT   , 
     M              GATOR , GAPOR , 
     I              HITEM                            )
*
      IMPLICIT NONE
*
*"   [PARAM]
#include        "zcdim.F"                    !" ʻ, ȿ
*
*   [MODIFY]
      DOUBLE PRECISION  GAU   ( IDIM, JDIM, KDIM )  !"    
      DOUBLE PRECISION  GAV   ( IDIM, JDIM, KDIM )  !"    
      DOUBLE PRECISION  GAW   ( IDIM, JDIM, KDIM )  !" ľ 
      DOUBLE PRECISION  GAT   ( IDIM, JDIM, KDIM )  !"    
      DOUBLE PRECISION  GATOR ( IDIM, JDIM, KDIM )  !" ȥ 
      DOUBLE PRECISION  GAPOR ( IDIM, JDIM, KDIM )  !" ݥ 
*
*   [INPUT]
      CHARACTER  HITEM * 5                    !" ʲѿ̾
*
*   [INTERNAL WORK]
      DOUBLE PRECISION  ANORM  , ABSMAX
      INTEGER    I, J, K
*
      IF( HITEM(1:5) .EQ. 'GATOR' )THEN
         ANORM = ABSMAX
     I         ( GATOR, IDIM, JDIM, KDIM, IMAX, JMAX )
      ELSE IF( HITEM(1:5) .EQ. 'GAPOR' )THEN
         ANORM = ABSMAX
     I         ( GAPOR, IDIM, JDIM, KDIM, IMAX, JMAX )
      ELSE IF( HITEM(1:3) .EQ. 'GAU' )THEN
         ANORM = ABSMAX
     I         ( GAU, IDIM, JDIM, KDIM, IMAX, JMAX )
      ELSE IF( HITEM(1:3) .EQ. 'GAV' )THEN
         ANORM = ABSMAX
     I         ( GAV, IDIM, JDIM, KDIM, IMAX, JMAX )
      ELSE IF( HITEM(1:3) .EQ. 'GAW' )THEN
         ANORM = ABSMAX
     I         ( GAW, IDIM, JDIM, KDIM, IMAX, JMAX )
      ELSE IF( HITEM(1:3) .EQ. 'GAT' )THEN
         ANORM = ABSMAX
     I         ( GAT, IDIM, JDIM, KDIM, IMAX, JMAX )
      ELSE
         RETURN
      ENDIF
*
      DO 8100 K=1,KDIM
         DO 8100 J=1,JDIM
            DO 8100 I=1,IDIM
               GAU(I,J,K) = GAU(I,J,K) / ANORM 
               GAV(I,J,K) = GAV(I,J,K) / ANORM 
               GAW(I,J,K) = GAW(I,J,K) / ANORM 
               GAT(I,J,K) = GAT(I,J,K) / ANORM 
               GATOR(I,J,K) = GATOR(I,J,K) / ANORM 
               GAPOR(I,J,K) = GAPOR(I,J,K) / ANORM 
 8100 CONTINUE
      RETURN
      END
**********************************************************************
      FUNCTION ABSMAX      !"  κ֤ͤ
     I         ( DATA, IDIM, JDIM, KDIM, IMAX, JMAX )
*
      IMPLICIT NONE
*
*   [PARAM] 
      INTEGER    IDIM
      INTEGER    JDIM
      INTEGER    KDIM
*
*   [INPUT] 
      DOUBLE PRECISION DATA( IDIM, JDIM, KDIM )
      INTEGER    IMAX
      INTEGER    JMAX
*
*   [OUTPUT] 
      DOUBLE PRECISION ABSMAX
*
*   [INTERNAL WORK] 
      INTEGER    I, J, K
*
      ABSMAX = -1.E36
*
      DO 1100 K=1,KDIM
        DO 1100 J=1,JMAX
          DO 1100 I=1,IMAX
            IF ( ABS(DATA( I,J,K )) .GT. ABSMAX ) THEN
              ABSMAX = ABS(DATA( I,J,K ))
            ENDIF
 1100 CONTINUE
*
      RETURN
      END
