* PACKAGE USUBS       !" 롼
*
*"  [HIS] 90/08/31(numaguti)
*
***********************************************************************
      SUBROUTINE RESET     !" 򣰥ꥻå
     O         ( DATA  ,
     D           IDIM   )
*
      IMPLICIT NONE
*
*   [PARAM] 
      INTEGER    IDIM
*
*   [OUTPUT]       
      REAL       DATA ( IDIM )
*
*   [INTERNAL WORK] 
      INTEGER    I
*
      DO 1100 I = 1, IDIM
        DATA ( I ) = 0.  
 1100 CONTINUE
*
*
      RETURN
      END
***********************************************************************
      SUBROUTINE COPY     !" ʣ
     O         ( DATAO  ,
     I           DATAI  ,
     D           IDIM     )
*
      IMPLICIT NONE
*
*   [PARAM]
      INTEGER    IDIM
*
*   [OUTPUT]       
      REAL       DATAO ( IDIM )                !" ϥǡ
*
*   [INPUT] 
      REAL       DATAI ( IDIM )                !" ϥǡ
*
*   [INTERNAL WORK] 
      INTEGER    I
*
      DO 1100 I = 1, IDIM
        DATAO ( I ) = DATAI ( I )
 1100 CONTINUE
*
      RETURN
      END
***********************************************************************
      SUBROUTINE SETV   !" ˥顼ͤ򥻥å
     O         ( DATA  ,
     I           VALUE ,
     D           IDIM   )
*
      IMPLICIT NONE
*
*   [PARAM] 
      INTEGER    IDIM
*
*   [OUTPUT] 
      REAL       DATA ( IDIM )                 !" 
*
*   [INPUT] 
      REAL       VALUE                         !" ϥǡ
*
*   [INTERNAL WORK] 
      INTEGER    I
*
      DO 1100 I = 1, IDIM
        DATA ( I ) = VALUE
 1100 CONTINUE
*
      RETURN
      END
***********************************************************************
      SUBROUTINE FILLV  !" ΤϰϤͤ >>
     M         ( DATA  ,
     I           VALUE ,
     D           IMIN  , IMAX  , IDIM  , JMIN  , JMAX  , JDIM  ,
     D           KMIN  , KMAX                                   )
*
      IMPLICIT NONE
*
*   [PARAM] 
      INTEGER    IDIM
      INTEGER    JDIM
      INTEGER    KMAX
*
*   [MODIFY] 
      REAL       DATA ( IDIM, JDIM, KMAX )   !" ǡ
*
*   [INPUT] 
      REAL       VALUE                       !" ϥǡ
      INTEGER    IMIN                        !" 裱Ϥ
      INTEGER    IMAX                        !" 裱
      INTEGER    JMIN                        !" 裲Ϥ
      INTEGER    JMAX                        !" 裲
      INTEGER    KMIN                        !" 裳Ϥ
*
*   [INTERNAL WORK] 
      INTEGER    I, J, K
*
      DO 1100 K = KMIN, KMAX
        DO 1100 J = JMIN, JMAX
          DO 1100 I = IMIN, IMAX
            DATA ( I, J, K ) = VALUE
 1100 CONTINUE
*
*
      RETURN
      END
************************************************************************
      SUBROUTINE MAXMIN      !"  κǾͺͤ 
     I         ( DATA, IDIM, JDIM, KMAX, IMAX, JMAX, HITEM )
*
      IMPLICIT NONE
*
*   [PARAM] 
      INTEGER    IDIM
      INTEGER    JDIM
      INTEGER    KMAX
*
*   [INPUT] 
      REAL       DATA( IDIM, JDIM, KMAX )
      INTEGER    IMAX
      INTEGER    JMAX
      CHARACTER  HITEM*(*)                     !" ɽ
*
*   [INTERNAL WORK] 
      INTEGER    I, J, K
      INTEGER    IPMIN, JPMIN, KPMIN
      INTEGER    IPMAX, JPMAX, KPMAX
      REAL       DMIN, DMAX
*
      INTEGER    IUNIT                       !" ɸֹ
*
      CALL GLIGET( 'MSGUNIT', IUNIT )
*
      DMIN =  1.E36
      DMAX = -1.E36
*
      DO 1100 K=1,KMAX
        DO 1100 J=1,JMAX
          DO 1100 I=1,IMAX
*
            IF ( DATA( I,J,K ) .LT. DMIN ) THEN
              DMIN = DATA( I,J,K )
              IPMIN = I
              JPMIN = J
              KPMIN = K
            ENDIF
*
            IF ( DATA( I,J,K ) .GT. DMAX ) THEN
              DMAX = DATA( I,J,K )
              IPMAX = I
              JPMAX = J
              KPMAX = K
            ENDIF
*
 1100 CONTINUE
*
      WRITE (IUNIT,*) HITEM, ': min = ', DMIN,' at ', IPMIN,JPMIN,KPMIN
      WRITE (IUNIT,*) HITEM, ': max = ', DMAX,' at ', IPMAX,JPMAX,KPMAX
*
      RETURN
      END
